MusicAnalysis is a collection of Haskell modules to improve music analysing. 
Actuallly this library offers simple transformations like transpositions, tempo
changes, and so on.

To run MusicAnalysis library it must use these Haskell language extensions: 
\begin{description}
\item [MultiParamtypeClasses] This extension allows classes parametrics,
\item [TypeSynonymInstances] This extension allows instances over types,
\item [FlexibleInstances] This allows powerfull instances.
\end{description}

This is main module. Figure 
%\refFigure{ma1} 
expose architecture of Music Analysis library.

% \samifigure[height=3in,width=5in]{ma1}{Music Analysis}{ma1}

\begin{code}
-- |  
-- Maintainer : silva.samuel@alumni.uminho.pt
-- Stability  : experimental
-- Portability: HaXML, Haskore
-- main module
module Music.Analysis (
    module Music.Analysis.PF,
    module Music.Analysis.Base,
    module Music.Analysis.Script
    ) where
\end{code}

\begin{code}
import Music.Analysis.PF 
import Music.Analysis.Base hiding (toInteger)
import Music.Analysis.Script
import Script ()

\end{code}


